export type Maybe<T> = T | null;
export type Exact<T extends { [key: string]: any }> = { [K in keyof T]: T[K] };
/** All built-in and custom scalars, mapped to their actual values */
export type Scalars = {
  ID: string;
  String: string;
  Boolean: boolean;
  Int: number;
  Float: number;
  StakeAddress: any;
  DateTime: any;
  Hash28Hex: any;
  StakePoolID: any;
  Hash32Hex: any;
  Hex: any;
  VRFVerificationKey: any;
  Lovelace: any;
  BigInt: any;
  AssetFingerprint: any;
  JSON: any;
  JSONObject: any;
  IPv4: any;
  IPv6: any;
  Percentage: any;
  Timestamp: any;
};

export type ActiveStake = {
  __typename?: 'ActiveStake';
  address: Scalars['StakeAddress'];
  amount: Scalars['Lovelace'];
  epoch?: Maybe<Epoch>;
  epochNo: Scalars['Int'];
  stakePoolHash: Scalars['Hash28Hex'];
  stakePoolId: Scalars['StakePoolID'];
  registeredWith: StakePool;
};

export type ActiveStake_Aggregate = {
  __typename?: 'ActiveStake_aggregate';
  aggregate?: Maybe<ActiveStake_Aggregate_Fields>;
};

export type ActiveStake_Aggregate_Fields = {
  __typename?: 'ActiveStake_aggregate_fields';
  count: Scalars['String'];
  max: ActiveStake_Max_Fields;
  min: ActiveStake_Min_Fields;
  sum: ActiveStake_Sum_Fields;
};

export type ActiveStake_Bool_Exp = {
  _and?: Maybe<Array<Maybe<ActiveStake_Bool_Exp>>>;
  _not?: Maybe<ActiveStake_Bool_Exp>;
  _or?: Maybe<Array<Maybe<ActiveStake_Bool_Exp>>>;
  address?: Maybe<StakeAddress_Comparison_Exp>;
  amount?: Maybe<Text_Comparison_Exp>;
  epoch?: Maybe<Epoch_Bool_Exp>;
  epochNo?: Maybe<Int_Comparison_Exp>;
  stakePoolHash?: Maybe<Hash28Hex_Comparison_Exp>;
  stakePoolId?: Maybe<StakePoolId_Comparison_Exp>;
  registeredWith?: Maybe<StakePool_Bool_Exp>;
};

export type ActiveStake_Max_Fields = {
  __typename?: 'ActiveStake_max_fields';
  amount?: Maybe<Scalars['Lovelace']>;
};

export type ActiveStake_Min_Fields = {
  __typename?: 'ActiveStake_min_fields';
  amount?: Maybe<Scalars['Lovelace']>;
};

export type ActiveStake_Order_By = {
  address?: Maybe<Order_By>;
  amount?: Maybe<Order_By>;
  epoch?: Maybe<Epoch_Order_By>;
  epochNo?: Maybe<Order_By>;
  stakePoolHash?: Maybe<Order_By>;
  stakePoolId?: Maybe<Order_By>;
  registeredWith?: Maybe<StakePool_Order_By>;
};

export type ActiveStake_Sum_Fields = {
  __typename?: 'ActiveStake_sum_fields';
  amount?: Maybe<Scalars['Lovelace']>;
};

export type Ada = {
  __typename?: 'Ada';
  supply: AssetSupply;
};

export type AdaPots = {
  __typename?: 'AdaPots';
  deposits: Scalars['Lovelace'];
  fees: Scalars['Lovelace'];
  reserves: Scalars['Lovelace'];
  rewards: Scalars['Lovelace'];
  slotNo: Scalars['String'];
  treasury: Scalars['Lovelace'];
  utxo: Scalars['Lovelace'];
};

export type AlonzoGenesis = {
  __typename?: 'AlonzoGenesis';
  lovelacePerUTxOWord: Scalars['Lovelace'];
  executionPrices: ExecutionPrices;
  maxTxExUnits: ExecutionUnits;
  maxBlockExUnits: ExecutionUnits;
  maxValueSize: Scalars['Lovelace'];
  collateralPercentage: Scalars['Int'];
  maxCollateralInputs: Scalars['Int'];
};

export type Asset = {
  __typename?: 'Asset';
  assetId: Scalars['Hex'];
  assetName?: Maybe<Scalars['Hex']>;
  decimals?: Maybe<Scalars['Int']>;
  description?: Maybe<Scalars['String']>;
  fingerprint?: Maybe<Scalars['AssetFingerprint']>;
  logo?: Maybe<Scalars['String']>;
  metadataHash?: Maybe<Scalars['String']>;
  tokenMints: Array<Maybe<TokenMint>>;
  tokenMints_aggregate: TokenMint_Aggregate;
  name?: Maybe<Scalars['String']>;
  policyId: Scalars['Hash28Hex'];
  ticker?: Maybe<Scalars['String']>;
  url?: Maybe<Scalars['String']>;
};


export type AssetTokenMintsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<TokenMint_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<TokenMint_Bool_Exp>;
};


export type AssetTokenMints_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<TokenMint_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<TokenMint_Bool_Exp>;
};

export type Asset_Aggregate = {
  __typename?: 'Asset_aggregate';
  aggregate?: Maybe<Asset_Aggregate_Fields>;
};

export type Asset_Aggregate_Fields = {
  __typename?: 'Asset_aggregate_fields';
  count: Scalars['String'];
};

export type Asset_Bool_Exp = {
  _and?: Maybe<Array<Maybe<Asset_Bool_Exp>>>;
  _not?: Maybe<Asset_Bool_Exp>;
  _or?: Maybe<Array<Maybe<Asset_Bool_Exp>>>;
  ticker?: Maybe<Text_Comparison_Exp>;
  assetId?: Maybe<Hex_Comparison_Exp>;
  assetName?: Maybe<Hex_Comparison_Exp>;
  decimals?: Maybe<Int_Comparison_Exp>;
  description?: Maybe<Text_Comparison_Exp>;
  fingerprint?: Maybe<AssetFingerprint_Comparison_Exp>;
  logo?: Maybe<Text_Comparison_Exp>;
  name?: Maybe<Text_Comparison_Exp>;
  policyId?: Maybe<Hash28Hex_Comparison_Exp>;
  tokenMints?: Maybe<TokenMint_Bool_Exp>;
  url?: Maybe<Text_Comparison_Exp>;
};

export type Asset_Order_By = {
  assetId?: Maybe<Order_By>;
  decimals?: Maybe<Order_By>;
  fingerprint?: Maybe<Order_By>;
  name?: Maybe<Order_By>;
};

export type AssetBalance = {
  __typename?: 'AssetBalance';
  asset: Asset;
  quantity: Scalars['String'];
};


export type AssetFingerprint_Comparison_Exp = {
  _eq?: Maybe<Scalars['String']>;
  _in?: Maybe<Array<Maybe<Scalars['String']>>>;
  _neq?: Maybe<Scalars['String']>;
  _nin?: Maybe<Array<Maybe<Scalars['String']>>>;
};

export type AssetSupply = {
  __typename?: 'AssetSupply';
  circulating: Scalars['String'];
  max: Scalars['String'];
  total?: Maybe<Scalars['String']>;
};

export type AssetSupply_Bool_Exp = {
  _and?: Maybe<Array<Maybe<AssetSupply_Bool_Exp>>>;
  _not?: Maybe<AssetSupply_Bool_Exp>;
  _or?: Maybe<Array<Maybe<AssetSupply_Bool_Exp>>>;
  circulating?: Maybe<Text_Comparison_Exp>;
  max?: Maybe<Text_Comparison_Exp>;
  total?: Maybe<Text_Comparison_Exp>;
};

export type AssetSupply_Order_By = {
  circulating?: Maybe<Order_By>;
  max?: Maybe<Order_By>;
  total?: Maybe<Order_By>;
};


export type Block = {
  __typename?: 'Block';
  epoch?: Maybe<Epoch>;
  epochNo?: Maybe<Scalars['Int']>;
  fees: Scalars['Lovelace'];
  forgedAt: Scalars['DateTime'];
  slotLeader: SlotLeader;
  hash: Scalars['Hash32Hex'];
  number?: Maybe<Scalars['Int']>;
  opCert?: Maybe<Scalars['Hash32Hex']>;
  slotInEpoch?: Maybe<Scalars['String']>;
  slotNo?: Maybe<Scalars['String']>;
  previousBlock?: Maybe<Block>;
  protocolVersion?: Maybe<Scalars['JSONObject']>;
  nextBlock?: Maybe<Block>;
  size: Scalars['Int'];
  transactions: Array<Maybe<Transaction>>;
  transactions_aggregate: Transaction_Aggregate;
  transactionsCount: Scalars['String'];
  vrfKey?: Maybe<Scalars['VRFVerificationKey']>;
};


export type BlockTransactionsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Transaction_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Transaction_Bool_Exp>;
};


export type BlockTransactions_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Transaction_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Transaction_Bool_Exp>;
};

export type Block_Aggregate = {
  __typename?: 'Block_aggregate';
  aggregate?: Maybe<Block_Aggregate_Fields>;
};

export type Block_Aggregate_Fields = {
  __typename?: 'Block_aggregate_fields';
  count: Scalars['String'];
  max: Block_Max_Fields;
  min: Block_Min_Fields;
  sum: Block_Sum_Fields;
};

export type Block_Bool_Exp = {
  _and?: Maybe<Array<Maybe<Block_Bool_Exp>>>;
  _not?: Maybe<Block_Bool_Exp>;
  _or?: Maybe<Array<Maybe<Block_Bool_Exp>>>;
  forgedAt?: Maybe<Date_Comparison_Exp>;
  slotLeader?: Maybe<SlotLeader_Bool_Exp>;
  epoch?: Maybe<Epoch_Bool_Exp>;
  fees?: Maybe<Text_Comparison_Exp>;
  hash?: Maybe<Hash32Hex_Comparison_Exp>;
  number?: Maybe<Int_Comparison_Exp>;
  previousBlock?: Maybe<Block_Bool_Exp>;
  nextBlock?: Maybe<Block_Bool_Exp>;
  size?: Maybe<Int_Comparison_Exp>;
  slotInEpoch?: Maybe<Int_Comparison_Exp>;
  slotNo?: Maybe<Text_Comparison_Exp>;
  transactions?: Maybe<Transaction_Bool_Exp>;
  transactionsCount?: Maybe<Text_Comparison_Exp>;
  vrfKey?: Maybe<VrfVerificationKey_Comparison_Exp>;
};

export type Block_Max_Fields = {
  __typename?: 'Block_max_fields';
  fees?: Maybe<Scalars['Lovelace']>;
  size?: Maybe<Scalars['Int']>;
};

export type Block_Min_Fields = {
  __typename?: 'Block_min_fields';
  fees?: Maybe<Scalars['Lovelace']>;
  size?: Maybe<Scalars['Int']>;
};

export type Block_Order_By = {
  forgedAt?: Maybe<Order_By>;
  slotLeader?: Maybe<SlotLeader_Order_By>;
  epoch?: Maybe<Epoch_Order_By>;
  fees?: Maybe<Order_By>;
  hash?: Maybe<Order_By>;
  number?: Maybe<Order_By_With_Nulls>;
  size?: Maybe<Order_By>;
  slotNo?: Maybe<Order_By_With_Nulls>;
  transactionsCount?: Maybe<Order_By>;
  vrfKey?: Maybe<Order_By_With_Nulls>;
};

export type Block_Sum_Fields = {
  __typename?: 'Block_sum_fields';
  fees?: Maybe<Scalars['Lovelace']>;
  size?: Maybe<Scalars['BigInt']>;
};

export type Boolean_Comparison_Exp = {
  _eq?: Maybe<Scalars['Boolean']>;
  _gt?: Maybe<Scalars['Boolean']>;
  _gte?: Maybe<Scalars['Boolean']>;
  _in?: Maybe<Array<Scalars['Boolean']>>;
  _is_null?: Maybe<Scalars['Boolean']>;
  _lt?: Maybe<Scalars['Boolean']>;
  _lte?: Maybe<Scalars['Boolean']>;
  _neq?: Maybe<Scalars['Boolean']>;
  _nin?: Maybe<Array<Scalars['Boolean']>>;
};

export type ByronBlockVersionData = {
  __typename?: 'ByronBlockVersionData';
  scriptVersion: Scalars['Int'];
  slotDuration: Scalars['Int'];
  maxBlockSize: Scalars['Int'];
  maxHeaderSize: Scalars['Int'];
  maxTxSize: Scalars['Int'];
  maxProposalSize: Scalars['Int'];
  mpcThd: Scalars['String'];
  heavyDelThd: Scalars['String'];
  updateVoteThd: Scalars['String'];
  updateProposalThd: Scalars['String'];
  updateImplicit: Scalars['String'];
  softforkRule: ByronSoftForkRule;
  txFeePolicy: ByronTxFeePolicy;
  unlockStakeEpoch: Scalars['String'];
};

export type ByronGenesis = {
  __typename?: 'ByronGenesis';
  bootStakeholders: Scalars['JSONObject'];
  heavyDelegation: Scalars['JSONObject'];
  startTime: Scalars['Timestamp'];
  nonAvvmBalances: Scalars['JSONObject'];
  blockVersionData: ByronBlockVersionData;
  protocolConsts: ByronProtocolConsts;
  avvmDistr: Scalars['JSONObject'];
};

export type ByronProtocolConsts = {
  __typename?: 'ByronProtocolConsts';
  k: Scalars['Int'];
  protocolMagic?: Maybe<Scalars['Int']>;
};

export type ByronSoftForkRule = {
  __typename?: 'ByronSoftForkRule';
  initThd: Scalars['String'];
  minThd: Scalars['String'];
  thdDecrement: Scalars['String'];
};

export type ByronTxFeePolicy = {
  __typename?: 'ByronTxFeePolicy';
  summand: Scalars['String'];
  multiplier: Scalars['String'];
};

export type Cardano = {
  __typename?: 'Cardano';
  tip: Block;
  currentEpoch: Epoch;
};

export type CardanoDbMeta = {
  __typename?: 'CardanoDbMeta';
  initialized: Scalars['Boolean'];
  syncPercentage: Scalars['Percentage'];
};

export type CollateralInput = {
  __typename?: 'CollateralInput';
  address: Scalars['String'];
  sourceTransaction: Transaction;
  sourceTxHash: Scalars['Hash32Hex'];
  sourceTxIndex: Scalars['Int'];
  tokens: Array<Maybe<Token>>;
  tokens_aggregate: Token_Aggregate;
  transaction: Transaction;
  txHash: Scalars['Hash32Hex'];
  value: Scalars['Lovelace'];
};

export type CollateralInput_Aggregate = {
  __typename?: 'CollateralInput_aggregate';
  aggregate?: Maybe<TransactionInput_Aggregate_Fields>;
};

export type CollateralInput_Aggregate_Fields = {
  __typename?: 'CollateralInput_aggregate_fields';
  count: Scalars['String'];
  max: CollateralInput_Max_Fields;
  min: CollateralInput_Min_Fields;
  sum: CollateralInput_Sum_Fields;
};

export type CollateralInput_Bool_Exp = {
  _and?: Maybe<Array<Maybe<CollateralInput_Bool_Exp>>>;
  _not?: Maybe<CollateralInput_Bool_Exp>;
  _or?: Maybe<Array<Maybe<CollateralInput_Bool_Exp>>>;
  address?: Maybe<Text_Comparison_Exp>;
  sourceTransaction?: Maybe<Transaction_Bool_Exp>;
  tokens?: Maybe<Token_Bool_Exp>;
  transaction?: Maybe<Transaction_Bool_Exp>;
  value?: Maybe<Text_Comparison_Exp>;
};

export type CollateralInput_Max_Fields = {
  __typename?: 'CollateralInput_max_fields';
  tokens?: Maybe<Token_Max_Fields>;
  value?: Maybe<Scalars['Lovelace']>;
};

export type CollateralInput_Min_Fields = {
  __typename?: 'CollateralInput_min_fields';
  tokens?: Maybe<Token_Min_Fields>;
  value?: Maybe<Scalars['Lovelace']>;
};

export type CollateralInput_Order_By = {
  address?: Maybe<Order_By>;
  sourceTxHash?: Maybe<Order_By>;
  transaction?: Maybe<Transaction_Order_By>;
  txHash?: Maybe<Order_By>;
  value?: Maybe<Order_By>;
};

export type CollateralInput_Sum_Fields = {
  __typename?: 'CollateralInput_sum_fields';
  tokens?: Maybe<Token_Sum_Fields>;
  value?: Maybe<Scalars['Lovelace']>;
};

export type CollateralOutput = {
  __typename?: 'CollateralOutput';
  address: Scalars['String'];
  addressHasScript: Scalars['Boolean'];
  datum?: Maybe<Datum>;
  index: Scalars['Int'];
  paymentCredential?: Maybe<Scalars['Hash28Hex']>;
  script?: Maybe<Script>;
  transaction: Transaction;
  txHash: Scalars['Hash32Hex'];
  value: Scalars['Lovelace'];
};

export type CollateralOutput_Aggregate = {
  __typename?: 'CollateralOutput_aggregate';
  aggregate?: Maybe<CollateralOutput_Aggregate_Fields>;
};

export type CollateralOutput_Aggregate_Fields = {
  __typename?: 'CollateralOutput_aggregate_fields';
  count: Scalars['String'];
  max: CollateralOutput_Max_Fields;
  min: CollateralOutput_Min_Fields;
  sum: CollateralOutput_Sum_Fields;
};

export type CollateralOutput_Bool_Exp = {
  _and?: Maybe<Array<Maybe<CollateralOutput_Bool_Exp>>>;
  _not?: Maybe<CollateralOutput_Bool_Exp>;
  _or?: Maybe<Array<Maybe<CollateralOutput_Bool_Exp>>>;
  address?: Maybe<Text_Comparison_Exp>;
  addressHasScript?: Maybe<Boolean_Comparison_Exp>;
  datum?: Maybe<Datum_Bool_Exp>;
  index?: Maybe<Int_Comparison_Exp>;
  script?: Maybe<Script_Bool_Exp>;
  transaction?: Maybe<Transaction_Bool_Exp>;
  value?: Maybe<Text_Comparison_Exp>;
};

export enum CollateralOutput_Distinct_On {
  Address = 'address'
}

export type CollateralOutput_Max_Fields = {
  __typename?: 'CollateralOutput_max_fields';
  value?: Maybe<Scalars['Lovelace']>;
};

export type CollateralOutput_Min_Fields = {
  __typename?: 'CollateralOutput_min_fields';
  value?: Maybe<Scalars['Lovelace']>;
};

export type CollateralOutput_Order_By = {
  address?: Maybe<Order_By>;
  addressHasScript?: Maybe<Order_By>;
  datum?: Maybe<Transaction_Order_By>;
  index?: Maybe<Order_By>;
  txHash?: Maybe<Order_By>;
  value?: Maybe<Order_By>;
};

export type CollateralOutput_Sum_Fields = {
  __typename?: 'CollateralOutput_sum_fields';
  value?: Maybe<Scalars['Lovelace']>;
};

export type Date_Comparison_Exp = {
  _eq?: Maybe<Scalars['DateTime']>;
  _gt?: Maybe<Scalars['DateTime']>;
  _gte?: Maybe<Scalars['DateTime']>;
  _in?: Maybe<Array<Maybe<Scalars['DateTime']>>>;
  _lt?: Maybe<Scalars['DateTime']>;
  _lte?: Maybe<Scalars['DateTime']>;
  _neq?: Maybe<Scalars['DateTime']>;
  _nin?: Maybe<Array<Maybe<Scalars['DateTime']>>>;
};


export type Datum = {
  __typename?: 'Datum';
  bytes: Scalars['Hex'];
  hash: Scalars['Hash32Hex'];
  firstIncludedIn: Transaction;
  value: Scalars['JSONObject'];
};

export type Datum_Bool_Exp = {
  firstIncludedIn?: Maybe<Transaction_Bool_Exp>;
  hash?: Maybe<Hex_Comparison_Exp>;
};

export type Delegation = {
  __typename?: 'Delegation';
  address: Scalars['StakeAddress'];
  redeemer?: Maybe<Redeemer>;
  stakePool: StakePool;
  stakePoolHash: Scalars['Hash28Hex'];
  stakePoolId: Scalars['StakePoolID'];
  transaction?: Maybe<Transaction>;
};

export type Delegation_Aggregate = {
  __typename?: 'Delegation_aggregate';
  aggregate?: Maybe<Delegation_Aggregate_Fields>;
};

export type Delegation_Aggregate_Fields = {
  __typename?: 'Delegation_aggregate_fields';
  count?: Maybe<Scalars['String']>;
};

export type Delegation_Bool_Exp = {
  _and?: Maybe<Array<Maybe<Delegation_Bool_Exp>>>;
  _not?: Maybe<Delegation_Bool_Exp>;
  _or?: Maybe<Array<Maybe<Delegation_Bool_Exp>>>;
  address?: Maybe<StakeAddress_Comparison_Exp>;
  stakePool?: Maybe<StakePool_Bool_Exp>;
  stakePoolHash?: Maybe<Hash28Hex_Comparison_Exp>;
  stakePoolId?: Maybe<StakePoolId_Comparison_Exp>;
  transaction?: Maybe<Transaction_Bool_Exp>;
};

export type Delegation_Order_By = {
  address?: Maybe<Order_By>;
  stakePool?: Maybe<StakePool_Order_By>;
  stakePoolHash?: Maybe<Order_By>;
  stakePoolId?: Maybe<Order_By>;
  transaction?: Maybe<Transaction_Order_By>;
};

export type Epoch = {
  __typename?: 'Epoch';
  activeStake?: Maybe<Array<Maybe<ActiveStake>>>;
  activeStake_aggregate?: Maybe<ActiveStake_Aggregate>;
  adaPots?: Maybe<AdaPots>;
  blocks: Array<Block>;
  blocks_aggregate: Block_Aggregate;
  blocksCount: Scalars['String'];
  fees: Scalars['Lovelace'];
  output: Scalars['Lovelace'];
  nonce?: Maybe<Scalars['Hash32Hex']>;
  number: Scalars['Int'];
  protocolParams?: Maybe<ProtocolParams>;
  transactionsCount: Scalars['String'];
  startedAt: Scalars['DateTime'];
  lastBlockTime: Scalars['DateTime'];
};


export type EpochBlocksArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Block_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Block_Bool_Exp>;
};


export type EpochBlocks_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Block_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Block_Bool_Exp>;
};

export type Epoch_Aggregate = {
  __typename?: 'Epoch_aggregate';
  aggregate: Epoch_Aggregate_Fields;
};

export type Epoch_Aggregate_Fields = {
  __typename?: 'Epoch_aggregate_fields';
  count: Scalars['String'];
  max: Epoch_Max_Fields;
  min: Epoch_Min_Fields;
  sum: Epoch_Sum_Fields;
};

export type Epoch_Bool_Exp = {
  _and?: Maybe<Array<Maybe<Epoch_Bool_Exp>>>;
  _not?: Maybe<Epoch_Bool_Exp>;
  _or?: Maybe<Array<Maybe<Epoch_Bool_Exp>>>;
  blocks?: Maybe<Block_Bool_Exp>;
  blocksCount?: Maybe<Text_Comparison_Exp>;
  fees?: Maybe<Text_Comparison_Exp>;
  number?: Maybe<Int_Comparison_Exp>;
  output?: Maybe<Text_Comparison_Exp>;
  startedAt?: Maybe<Date_Comparison_Exp>;
  transactionsCount?: Maybe<Text_Comparison_Exp>;
};

export type Epoch_Max_Fields = {
  __typename?: 'Epoch_max_fields';
  blocksCount: Scalars['Int'];
  fees: Scalars['Lovelace'];
  number: Scalars['Int'];
  output: Scalars['Lovelace'];
  transactionsCount: Scalars['String'];
};

export type Epoch_Min_Fields = {
  __typename?: 'Epoch_min_fields';
  blocksCount: Scalars['String'];
  fees: Scalars['Lovelace'];
  output: Scalars['Lovelace'];
  transactionsCount: Scalars['String'];
};

export type Epoch_Order_By = {
  blocksCount?: Maybe<Order_By>;
  fees?: Maybe<Order_By>;
  number?: Maybe<Order_By>;
  output?: Maybe<Order_By>;
  transactionsCount?: Maybe<Order_By>;
};

export type Epoch_Sum_Fields = {
  __typename?: 'Epoch_sum_fields';
  blocksCount: Scalars['String'];
  fees: Scalars['Lovelace'];
  output: Scalars['Lovelace'];
  transactionsCount: Scalars['String'];
};

export type ExecutionPrice = {
  __typename?: 'ExecutionPrice';
  numerator: Scalars['Int'];
  denominator: Scalars['Int'];
};

export type ExecutionPrices = {
  __typename?: 'ExecutionPrices';
  prSteps: ExecutionPrice;
  prMem: ExecutionPrice;
};

export type ExecutionUnits = {
  __typename?: 'ExecutionUnits';
  exUnitsMem: Scalars['String'];
  exUnitsSteps: Scalars['String'];
};

export type Float_Comparison_Exp = {
  _eq?: Maybe<Scalars['Float']>;
  _gt?: Maybe<Scalars['Float']>;
  _gte?: Maybe<Scalars['Float']>;
  _in?: Maybe<Array<Scalars['Float']>>;
  _is_null?: Maybe<Scalars['Boolean']>;
  _lt?: Maybe<Scalars['Float']>;
  _lte?: Maybe<Scalars['Float']>;
  _neq?: Maybe<Scalars['Float']>;
  _nin?: Maybe<Array<Scalars['Float']>>;
};

export type Genesis = {
  __typename?: 'Genesis';
  alonzo?: Maybe<AlonzoGenesis>;
  byron?: Maybe<ByronGenesis>;
  shelley?: Maybe<ShelleyGenesis>;
};


export type Hash28Hex_Comparison_Exp = {
  _eq?: Maybe<Scalars['Hash28Hex']>;
  _in?: Maybe<Array<Maybe<Scalars['Hash28Hex']>>>;
  _neq?: Maybe<Scalars['Hash28Hex']>;
  _nin?: Maybe<Array<Maybe<Scalars['Hash28Hex']>>>;
};


export type Hash32Hex_Comparison_Exp = {
  _eq?: Maybe<Scalars['Hash32Hex']>;
  _in?: Maybe<Array<Maybe<Scalars['Hash32Hex']>>>;
  _neq?: Maybe<Scalars['Hash32Hex']>;
  _nin?: Maybe<Array<Maybe<Scalars['Hash32Hex']>>>;
};


export type Hex_Comparison_Exp = {
  _eq?: Maybe<Scalars['Hex']>;
  _in?: Maybe<Array<Maybe<Scalars['Hex']>>>;
  _neq?: Maybe<Scalars['Hex']>;
  _nin?: Maybe<Array<Maybe<Scalars['Hex']>>>;
};

export type Int_Comparison_Exp = {
  _eq?: Maybe<Scalars['Int']>;
  _gt?: Maybe<Scalars['Int']>;
  _gte?: Maybe<Scalars['Int']>;
  _in?: Maybe<Array<Scalars['Int']>>;
  _is_null?: Maybe<Scalars['Boolean']>;
  _lt?: Maybe<Scalars['Int']>;
  _lte?: Maybe<Scalars['Int']>;
  _neq?: Maybe<Scalars['Int']>;
  _nin?: Maybe<Array<Scalars['Int']>>;
};






export type Mutation = {
  __typename?: 'Mutation';
  submitTransaction: TransactionSubmitResponse;
};


export type MutationSubmitTransactionArgs = {
  transaction: Scalars['String'];
};

export enum Order_By {
  Asc = 'asc',
  Desc = 'desc'
}

export enum Order_By_With_Nulls {
  Asc = 'asc',
  AscNullsFirst = 'asc_nulls_first',
  AscNullsLast = 'asc_nulls_last',
  Desc = 'desc',
  DescNullsFirst = 'desc_nulls_first',
  DescNullsLast = 'desc_nulls_last'
}

export type PaymentAddress = {
  __typename?: 'PaymentAddress';
  address: Scalars['String'];
  summary?: Maybe<PaymentAddressSummary>;
};


export type PaymentAddressSummaryArgs = {
  atBlock?: Maybe<Scalars['Int']>;
};

export type PaymentAddressSummary = {
  __typename?: 'PaymentAddressSummary';
  assetBalances: Array<Maybe<AssetBalance>>;
  utxosCount: Scalars['Int'];
};


export type Percentage_Comparison_Exp = {
  _eq?: Maybe<Scalars['Percentage']>;
  _gt?: Maybe<Scalars['Percentage']>;
  _gte?: Maybe<Scalars['Percentage']>;
  _lt?: Maybe<Scalars['Percentage']>;
  _lte?: Maybe<Scalars['Percentage']>;
  _neq?: Maybe<Scalars['Percentage']>;
};

export type ProtocolParams = {
  __typename?: 'ProtocolParams';
  a0: Scalars['Float'];
  coinsPerUtxoByte?: Maybe<Scalars['Lovelace']>;
  collateralPercent?: Maybe<Scalars['Int']>;
  costModels?: Maybe<Scalars['JSONObject']>;
  decentralisationParam: Scalars['Float'];
  eMax: Scalars['Int'];
  extraEntropy?: Maybe<Scalars['JSONObject']>;
  keyDeposit: Scalars['Lovelace'];
  maxBlockBodySize: Scalars['Int'];
  maxBlockExMem?: Maybe<Scalars['String']>;
  maxBlockExSteps?: Maybe<Scalars['String']>;
  maxBlockHeaderSize: Scalars['Int'];
  maxCollateralInputs?: Maybe<Scalars['Int']>;
  maxTxExMem?: Maybe<Scalars['String']>;
  maxTxExSteps?: Maybe<Scalars['String']>;
  maxTxSize: Scalars['Int'];
  maxValSize?: Maybe<Scalars['String']>;
  minFeeA: Scalars['Int'];
  minFeeB: Scalars['Int'];
  minPoolCost: Scalars['Lovelace'];
  minUTxOValue: Scalars['Lovelace'];
  nOpt: Scalars['Int'];
  poolDeposit: Scalars['Lovelace'];
  priceMem?: Maybe<Scalars['Float']>;
  priceStep?: Maybe<Scalars['Float']>;
  protocolVersion: Scalars['JSONObject'];
  rho: Scalars['Float'];
  tau: Scalars['Float'];
};

export type Query = {
  __typename?: 'Query';
  activeStake: Array<Maybe<ActiveStake>>;
  activeStake_aggregate: ActiveStake_Aggregate;
  ada: Ada;
  assets: Array<Maybe<Asset>>;
  assets_aggregate: Asset_Aggregate;
  blocks: Array<Maybe<Block>>;
  blocks_aggregate: Block_Aggregate;
  cardano: Cardano;
  cardanoDbMeta: CardanoDbMeta;
  collateralInputs: Array<Maybe<CollateralInput>>;
  collateralInputs_aggregate: CollateralInput_Aggregate;
  collateralOutputs: Array<Maybe<CollateralOutput>>;
  collateralOutputs_aggregate: CollateralOutput_Aggregate;
  delegations?: Maybe<Array<Maybe<Delegation>>>;
  delegations_aggregate?: Maybe<Delegation_Aggregate>;
  epochs: Array<Maybe<Epoch>>;
  epochs_aggregate: Epoch_Aggregate;
  genesis: Genesis;
  paymentAddresses?: Maybe<Array<Maybe<PaymentAddress>>>;
  redeemers: Array<Maybe<Redeemer>>;
  redeemers_aggregate: Redeemer_Aggregate;
  rewards: Array<Maybe<Reward>>;
  rewards_aggregate: Reward_Aggregate;
  scripts: Array<Maybe<Script>>;
  scripts_aggregate: Script_Aggregate;
  stakeDeregistrations?: Maybe<Array<Maybe<StakeDeregistration>>>;
  stakeDeregistrations_aggregate?: Maybe<StakeDeregistration_Aggregate>;
  stakePools?: Maybe<Array<Maybe<StakePool>>>;
  stakePools_aggregate?: Maybe<StakePool_Aggregate>;
  stakeRegistrations?: Maybe<Array<Maybe<StakeRegistration>>>;
  stakeRegistrations_aggregate?: Maybe<StakeRegistration_Aggregate>;
  tokenMints: Array<Maybe<TokenMint>>;
  tokenMints_aggregate: TokenMint_Aggregate;
  transactions: Array<Maybe<Transaction>>;
  transactions_aggregate: Transaction_Aggregate;
  utxos: Array<Maybe<TransactionOutput>>;
  utxos_aggregate: TransactionOutput_Aggregate;
  withdrawals: Array<Maybe<Withdrawal>>;
  withdrawals_aggregate?: Maybe<Withdrawal_Aggregate>;
};


export type QueryActiveStakeArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<ActiveStake_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<ActiveStake_Bool_Exp>;
};


export type QueryActiveStake_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<ActiveStake_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<ActiveStake_Bool_Exp>;
};


export type QueryAssetsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Asset_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Asset_Bool_Exp>;
};


export type QueryAssets_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Asset_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Asset_Bool_Exp>;
};


export type QueryBlocksArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Block_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Block_Bool_Exp>;
};


export type QueryBlocks_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Block_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Block_Bool_Exp>;
};


export type QueryCollateralInputsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<CollateralInput_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<CollateralInput_Bool_Exp>;
};


export type QueryCollateralInputs_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<CollateralInput_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<CollateralInput_Bool_Exp>;
};


export type QueryCollateralOutputsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<CollateralOutput_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<CollateralOutput_Bool_Exp>;
};


export type QueryCollateralOutputs_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<CollateralOutput_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<CollateralOutput_Bool_Exp>;
};


export type QueryDelegationsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Delegation_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Delegation_Bool_Exp>;
};


export type QueryDelegations_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Delegation_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Delegation_Bool_Exp>;
};


export type QueryEpochsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Epoch_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Epoch_Bool_Exp>;
};


export type QueryEpochs_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Epoch_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Epoch_Bool_Exp>;
};


export type QueryPaymentAddressesArgs = {
  addresses: Array<Maybe<Scalars['String']>>;
};


export type QueryRedeemersArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Redeemer_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Redeemer_Bool_Exp>;
};


export type QueryRedeemers_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Redeemer_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Redeemer_Bool_Exp>;
};


export type QueryRewardsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Reward_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Reward_Bool_Exp>;
};


export type QueryRewards_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Reward_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Reward_Bool_Exp>;
};


export type QueryScriptsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Script_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Script_Bool_Exp>;
};


export type QueryScripts_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Script_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Script_Bool_Exp>;
};


export type QueryStakeDeregistrationsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<StakeDeregistration_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<StakeDeregistration_Bool_Exp>;
};


export type QueryStakeDeregistrations_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<StakeDeregistration_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<StakeDeregistration_Bool_Exp>;
};


export type QueryStakePoolsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<StakePool_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<StakePool_Bool_Exp>;
};


export type QueryStakePools_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<StakePool_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<StakePool_Bool_Exp>;
};


export type QueryStakeRegistrationsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<StakeRegistration_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<StakeRegistration_Bool_Exp>;
};


export type QueryStakeRegistrations_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<StakeRegistration_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<StakeRegistration_Bool_Exp>;
};


export type QueryTokenMintsArgs = {
  distinct_on?: Maybe<Array<TokenMint_Aggregate_Distinct_On>>;
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<TokenMint_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<TokenMint_Bool_Exp>;
};


export type QueryTokenMints_AggregateArgs = {
  distinct_on?: Maybe<Array<TokenMint_Aggregate_Distinct_On>>;
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<TokenMint_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<TokenMint_Bool_Exp>;
};


export type QueryTransactionsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Transaction_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Transaction_Bool_Exp>;
};


export type QueryTransactions_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Transaction_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Transaction_Bool_Exp>;
};


export type QueryUtxosArgs = {
  distinct_on?: Maybe<Array<TransactionOutput_Distinct_On>>;
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<TransactionOutput_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<TransactionOutput_Bool_Exp>;
};


export type QueryUtxos_AggregateArgs = {
  distinct_on?: Maybe<Array<TransactionOutput_Distinct_On>>;
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<TransactionOutput_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<TransactionOutput_Bool_Exp>;
};


export type QueryWithdrawalsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Withdrawal_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Withdrawal_Bool_Exp>;
};


export type QueryWithdrawals_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Withdrawal_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Withdrawal_Bool_Exp>;
};

export type Redeemer = {
  __typename?: 'Redeemer';
  datum?: Maybe<Datum>;
  fee?: Maybe<Scalars['Lovelace']>;
  index: Scalars['Int'];
  purpose: Scalars['String'];
  scriptHash: Scalars['Hash28Hex'];
  transaction: Transaction;
  unitMem: Scalars['String'];
  unitSteps: Scalars['String'];
};

export type Redeemer_Aggregate = {
  __typename?: 'Redeemer_aggregate';
  aggregate?: Maybe<Redeemer_Aggregate_Fields>;
};

export type Redeemer_Aggregate_Fields = {
  __typename?: 'Redeemer_aggregate_fields';
  count: Scalars['String'];
  max: Redeemer_Max_Fields;
  min: Redeemer_Min_Fields;
  sum: Redeemer_Sum_Fields;
};

export type Redeemer_Bool_Exp = {
  _and?: Maybe<Array<Maybe<Redeemer_Bool_Exp>>>;
  _not?: Maybe<Redeemer_Bool_Exp>;
  _or?: Maybe<Array<Maybe<Redeemer_Bool_Exp>>>;
  datum?: Maybe<Datum_Bool_Exp>;
  fee?: Maybe<Text_Comparison_Exp>;
  index?: Maybe<Int_Comparison_Exp>;
  purpose?: Maybe<Text_Comparison_Exp>;
  scriptHash?: Maybe<Text_Comparison_Exp>;
  transaction?: Maybe<Transaction_Bool_Exp>;
  unitMem?: Maybe<Text_Comparison_Exp>;
  unitSteps?: Maybe<Text_Comparison_Exp>;
};

export type Redeemer_Max_Fields = {
  __typename?: 'Redeemer_max_fields';
  fee?: Maybe<Scalars['String']>;
  unitMem?: Maybe<Scalars['String']>;
  unitSteps?: Maybe<Scalars['String']>;
};

export type Redeemer_Min_Fields = {
  __typename?: 'Redeemer_min_fields';
  fee?: Maybe<Scalars['String']>;
  unitMem?: Maybe<Scalars['String']>;
  unitSteps?: Maybe<Scalars['String']>;
};

export type Redeemer_Order_By = {
  purpose?: Maybe<Order_By>;
  scriptHash?: Maybe<Order_By>;
  transaction?: Maybe<Transaction_Order_By>;
  unitMem?: Maybe<Order_By>;
  unitSteps?: Maybe<Order_By>;
};

export type Redeemer_Sum_Fields = {
  __typename?: 'Redeemer_sum_fields';
  fee?: Maybe<Scalars['String']>;
  unitMem?: Maybe<Scalars['String']>;
  unitSteps?: Maybe<Scalars['String']>;
};

export type Relay = {
  __typename?: 'Relay';
  ipv4?: Maybe<Scalars['IPv4']>;
  ipv6?: Maybe<Scalars['IPv6']>;
  dnsName?: Maybe<Scalars['String']>;
  dnsSrvName?: Maybe<Scalars['String']>;
  port?: Maybe<Scalars['Int']>;
};

export type Relay_Bool_Exp = {
  _and?: Maybe<Array<Maybe<Relay_Bool_Exp>>>;
  _not?: Maybe<Relay_Bool_Exp>;
  _or?: Maybe<Array<Maybe<Relay_Bool_Exp>>>;
  ipv4?: Maybe<Text_Comparison_Exp>;
  ipv6?: Maybe<Text_Comparison_Exp>;
  dnsName?: Maybe<Text_Comparison_Exp>;
  dnsSrvName?: Maybe<Text_Comparison_Exp>;
  port?: Maybe<Int_Comparison_Exp>;
};

export type Reward = {
  __typename?: 'Reward';
  address: Scalars['StakeAddress'];
  amount: Scalars['Lovelace'];
  earnedIn: Epoch;
  receivedIn?: Maybe<Epoch>;
  stakePool?: Maybe<StakePool>;
  type: Scalars['String'];
};

export type Reward_Aggregate = {
  __typename?: 'Reward_aggregate';
  aggregate?: Maybe<Reward_Aggregate_Fields>;
};

export type Reward_Aggregate_Fields = {
  __typename?: 'Reward_aggregate_fields';
  count: Scalars['String'];
  max: Reward_Max_Fields;
  min: Reward_Min_Fields;
  sum: Reward_Sum_Fields;
};

export type Reward_Bool_Exp = {
  _and?: Maybe<Array<Maybe<Reward_Bool_Exp>>>;
  _not?: Maybe<Reward_Bool_Exp>;
  _or?: Maybe<Array<Maybe<Reward_Bool_Exp>>>;
  address?: Maybe<StakeAddress_Comparison_Exp>;
  amount?: Maybe<Text_Comparison_Exp>;
  earnedIn?: Maybe<Epoch_Bool_Exp>;
  receivedIn?: Maybe<Epoch_Bool_Exp>;
  stakePool?: Maybe<StakePool_Bool_Exp>;
  type?: Maybe<Text_Comparison_Exp>;
};

export type Reward_Max_Fields = {
  __typename?: 'Reward_max_fields';
  amount?: Maybe<Scalars['Lovelace']>;
};

export type Reward_Min_Fields = {
  __typename?: 'Reward_min_fields';
  amount?: Maybe<Scalars['Lovelace']>;
};

export type Reward_Order_By = {
  address?: Maybe<Order_By>;
  amount?: Maybe<Order_By>;
  earnedIn?: Maybe<Epoch_Order_By>;
  receivedIn?: Maybe<Epoch_Order_By>;
  stakePool?: Maybe<StakePool_Order_By>;
  type?: Maybe<Order_By>;
};

export type Reward_Sum_Fields = {
  __typename?: 'Reward_sum_fields';
  amount?: Maybe<Scalars['Lovelace']>;
};

export type Script = {
  __typename?: 'Script';
  hash: Scalars['Hash28Hex'];
  serialisedSize?: Maybe<Scalars['Int']>;
  transaction: Transaction;
  type: Scalars['String'];
};

export type Script_Aggregate = {
  __typename?: 'Script_aggregate';
  aggregate?: Maybe<Script_Aggregate_Fields>;
};

export type Script_Aggregate_Fields = {
  __typename?: 'Script_aggregate_fields';
  count: Scalars['String'];
  max: Script_Max_Fields;
  min: Script_Min_Fields;
  sum: Script_Sum_Fields;
};

export type Script_Bool_Exp = {
  _and?: Maybe<Array<Maybe<Script_Bool_Exp>>>;
  _not?: Maybe<Script_Bool_Exp>;
  _or?: Maybe<Array<Maybe<Script_Bool_Exp>>>;
  serialisedSize?: Maybe<Int_Comparison_Exp>;
  transaction?: Maybe<Transaction_Bool_Exp>;
  type?: Maybe<Text_Comparison_Exp>;
};

export type Script_Max_Fields = {
  __typename?: 'Script_max_fields';
  serialisedSize?: Maybe<Scalars['Int']>;
};

export type Script_Min_Fields = {
  __typename?: 'Script_min_fields';
  serialisedSize?: Maybe<Scalars['Int']>;
};

export type Script_Order_By = {
  serialisedSize?: Maybe<Order_By>;
  transaction?: Maybe<Transaction_Order_By>;
  type?: Maybe<Order_By>;
};

export type Script_Sum_Fields = {
  __typename?: 'Script_sum_fields';
  serialisedSize?: Maybe<Scalars['BigInt']>;
};

export type ShelleyGenesis = {
  __typename?: 'ShelleyGenesis';
  activeSlotsCoeff: Scalars['Float'];
  epochLength: Scalars['Int'];
  genDelegs?: Maybe<Scalars['JSONObject']>;
  initialFunds: Scalars['JSONObject'];
  maxKESEvolutions: Scalars['Int'];
  maxLovelaceSupply: Scalars['Lovelace'];
  networkId: Scalars['String'];
  networkMagic: Scalars['Int'];
  protocolParams: ShelleyProtocolParams;
  securityParam: Scalars['Int'];
  slotLength: Scalars['Int'];
  slotsPerKESPeriod: Scalars['Int'];
  staking?: Maybe<ShelleyGenesisStaking>;
  systemStart: Scalars['String'];
  updateQuorum: Scalars['Int'];
};

export type ShelleyGenesisStaking = {
  __typename?: 'ShelleyGenesisStaking';
  pools: Scalars['JSONObject'];
  stake: Scalars['JSONObject'];
};

export type ShelleyProtocolParams = {
  __typename?: 'ShelleyProtocolParams';
  a0: Scalars['Float'];
  decentralisationParam: Scalars['Float'];
  eMax: Scalars['Int'];
  extraEntropy?: Maybe<Scalars['JSONObject']>;
  keyDeposit: Scalars['Lovelace'];
  maxBlockBodySize: Scalars['Int'];
  maxBlockHeaderSize: Scalars['Int'];
  maxTxSize: Scalars['Int'];
  minFeeA: Scalars['Int'];
  minFeeB: Scalars['Int'];
  minPoolCost: Scalars['Lovelace'];
  minUTxOValue: Scalars['Lovelace'];
  nOpt: Scalars['Int'];
  poolDeposit: Scalars['Lovelace'];
  protocolVersion: Scalars['JSONObject'];
  rho: Scalars['Float'];
  tau: Scalars['Float'];
};

export type SlotLeader = {
  __typename?: 'SlotLeader';
  description: Scalars['String'];
  hash: Scalars['Hash28Hex'];
  stakePool?: Maybe<StakePool>;
};

export type SlotLeader_Bool_Exp = {
  _and?: Maybe<Array<Maybe<SlotLeader_Bool_Exp>>>;
  _not?: Maybe<SlotLeader_Bool_Exp>;
  _or?: Maybe<Array<Maybe<SlotLeader_Bool_Exp>>>;
  description?: Maybe<Text_Comparison_Exp>;
  hash?: Maybe<Hash28Hex_Comparison_Exp>;
  stakePool?: Maybe<StakePool_Bool_Exp>;
};

export type SlotLeader_Order_By = {
  hash?: Maybe<Order_By>;
  stakePool?: Maybe<StakePool_Order_By>;
};


export type StakeAddress_Comparison_Exp = {
  _eq?: Maybe<Scalars['StakeAddress']>;
  _in?: Maybe<Array<Maybe<Scalars['StakeAddress']>>>;
  _neq?: Maybe<Scalars['StakeAddress']>;
  _nin?: Maybe<Array<Maybe<Scalars['StakeAddress']>>>;
};

export type StakeDeregistration = {
  __typename?: 'StakeDeregistration';
  address: Scalars['StakeAddress'];
  redeemer?: Maybe<Redeemer>;
  transaction: Transaction;
};

export type StakeDeregistration_Aggregate = {
  __typename?: 'StakeDeregistration_aggregate';
  aggregate?: Maybe<StakeDeregistration_Aggregate_Fields>;
};

export type StakeDeregistration_Aggregate_Fields = {
  __typename?: 'StakeDeregistration_aggregate_fields';
  count?: Maybe<Scalars['String']>;
};

export type StakeDeregistration_Bool_Exp = {
  _and?: Maybe<Array<Maybe<StakeDeregistration_Bool_Exp>>>;
  _not?: Maybe<StakeDeregistration_Bool_Exp>;
  _or?: Maybe<Array<Maybe<StakeDeregistration_Bool_Exp>>>;
  address?: Maybe<StakeAddress_Comparison_Exp>;
  transaction?: Maybe<Transaction_Bool_Exp>;
};

export type StakeDeregistration_Order_By = {
  address?: Maybe<Order_By>;
  transaction?: Maybe<Transaction_Order_By>;
};

export type StakePool = {
  __typename?: 'StakePool';
  activeStake: Array<Maybe<ActiveStake>>;
  activeStake_aggregate: ActiveStake_Aggregate;
  blocks: Array<Block>;
  blocks_aggregate: Block_Aggregate;
  delegators: Array<Maybe<Delegation>>;
  delegators_aggregate: Delegation_Aggregate;
  fixedCost: Scalars['Lovelace'];
  hash: Scalars['Hash28Hex'];
  id: Scalars['StakePoolID'];
  margin: Scalars['Float'];
  metadataHash?: Maybe<Scalars['Hash32Hex']>;
  owners: Array<StakePoolOwner>;
  pledge: Scalars['Lovelace'];
  relays?: Maybe<Array<Maybe<Relay>>>;
  retirements?: Maybe<Array<Maybe<StakePoolRetirement>>>;
  rewardAddress: Scalars['StakeAddress'];
  rewards: Array<Maybe<Reward>>;
  rewards_aggregate: Reward_Aggregate;
  updatedIn: Transaction;
  url?: Maybe<Scalars['String']>;
};


export type StakePoolActiveStakeArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<ActiveStake_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<ActiveStake_Bool_Exp>;
};


export type StakePoolActiveStake_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<ActiveStake_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<ActiveStake_Bool_Exp>;
};


export type StakePoolBlocksArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Block_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Block_Bool_Exp>;
};


export type StakePoolBlocks_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Block_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Block_Bool_Exp>;
};


export type StakePoolDelegatorsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Delegation_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Delegation_Bool_Exp>;
};


export type StakePoolDelegators_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Delegation_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Delegation_Bool_Exp>;
};


export type StakePoolRewards_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Reward_Order_By>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Reward_Bool_Exp>;
};

export type StakePool_Aggregate = {
  __typename?: 'StakePool_aggregate';
  aggregate?: Maybe<StakePool_Aggregate_Fields>;
};

export type StakePool_Aggregate_Fields = {
  __typename?: 'StakePool_aggregate_fields';
  count: Scalars['String'];
  max: StakePool_Max_Fields;
  min: StakePool_Min_Fields;
  sum: StakePool_Sum_Fields;
};

export type StakePool_Bool_Exp = {
  _and?: Maybe<Array<Maybe<StakePool_Bool_Exp>>>;
  _not?: Maybe<StakePool_Bool_Exp>;
  _or?: Maybe<Array<Maybe<StakePool_Bool_Exp>>>;
  hash?: Maybe<Hash28Hex_Comparison_Exp>;
  id?: Maybe<StakePoolId_Comparison_Exp>;
  margin?: Maybe<Float_Comparison_Exp>;
  metadataHash?: Maybe<Hash32Hex_Comparison_Exp>;
  owners?: Maybe<StakePoolOwner_Bool_Exp>;
  pledge?: Maybe<Text_Comparison_Exp>;
  registrationTransaction?: Maybe<Transaction_Bool_Exp>;
  relays?: Maybe<Relay_Bool_Exp>;
  retirements?: Maybe<StakePoolRetirement_Bool_Exp>;
  rewardAddress?: Maybe<Text_Comparison_Exp>;
  rewards?: Maybe<Reward_Bool_Exp>;
  url?: Maybe<Text_Comparison_Exp>;
};

export type StakePool_Max_Fields = {
  __typename?: 'StakePool_max_fields';
  fixedCost?: Maybe<Scalars['Lovelace']>;
  margin?: Maybe<Scalars['Float']>;
  pledge?: Maybe<Scalars['Lovelace']>;
};

export type StakePool_Min_Fields = {
  __typename?: 'StakePool_min_fields';
  fixedCost?: Maybe<Scalars['Lovelace']>;
  margin?: Maybe<Scalars['Float']>;
  pledge?: Maybe<Scalars['Lovelace']>;
};

export type StakePool_Order_By = {
  fixedCost?: Maybe<Order_By>;
  hash?: Maybe<Order_By>;
  id?: Maybe<Order_By>;
  margin?: Maybe<Order_By>;
  pledge?: Maybe<Order_By>;
  updatedIn?: Maybe<Transaction_Order_By>;
  url?: Maybe<Order_By>;
};

export type StakePool_Sum_Fields = {
  __typename?: 'StakePool_sum_fields';
  fixedCost?: Maybe<Scalars['Lovelace']>;
  margin?: Maybe<Scalars['Float']>;
  pledge?: Maybe<Scalars['Lovelace']>;
};


export type StakePoolId_Comparison_Exp = {
  _eq?: Maybe<Scalars['StakePoolID']>;
  _in?: Maybe<Array<Maybe<Scalars['StakePoolID']>>>;
  _neq?: Maybe<Scalars['StakePoolID']>;
  _nin?: Maybe<Array<Maybe<Scalars['StakePoolID']>>>;
};

export type StakePoolOwner = {
  __typename?: 'StakePoolOwner';
  hash: Scalars['Hash28Hex'];
};

export type StakePoolOwner_Bool_Exp = {
  _and?: Maybe<Array<Maybe<StakePoolOwner_Bool_Exp>>>;
  _not?: Maybe<StakePoolOwner_Bool_Exp>;
  _or?: Maybe<Array<Maybe<StakePoolOwner_Bool_Exp>>>;
  hash?: Maybe<Hash28Hex_Comparison_Exp>;
};

export type StakePoolRetirement = {
  __typename?: 'StakePoolRetirement';
  announcedIn?: Maybe<Transaction>;
  inEffectFrom: Scalars['Int'];
  retiredInEpoch?: Maybe<Epoch>;
};

export type StakePoolRetirement_Bool_Exp = {
  _and?: Maybe<Array<Maybe<StakePoolRetirement_Bool_Exp>>>;
  _not?: Maybe<StakePoolRetirement_Bool_Exp>;
  _or?: Maybe<Array<Maybe<StakePoolRetirement_Bool_Exp>>>;
  announcedIn?: Maybe<Transaction_Bool_Exp>;
  inEffectFrom?: Maybe<Int_Comparison_Exp>;
};

export type StakeRegistration = {
  __typename?: 'StakeRegistration';
  address: Scalars['StakeAddress'];
  transaction: Transaction;
};

export type StakeRegistration_Aggregate = {
  __typename?: 'StakeRegistration_aggregate';
  aggregate?: Maybe<StakeRegistration_Aggregate_Fields>;
};

export type StakeRegistration_Aggregate_Fields = {
  __typename?: 'StakeRegistration_aggregate_fields';
  count?: Maybe<Scalars['String']>;
};

export type StakeRegistration_Bool_Exp = {
  _and?: Maybe<Array<Maybe<StakeRegistration_Bool_Exp>>>;
  _not?: Maybe<StakeRegistration_Bool_Exp>;
  _or?: Maybe<Array<Maybe<StakeRegistration_Bool_Exp>>>;
  address?: Maybe<StakeAddress_Comparison_Exp>;
  transaction?: Maybe<Transaction_Bool_Exp>;
};

export type StakeRegistration_Order_By = {
  address?: Maybe<Order_By>;
  transaction?: Maybe<Transaction_Order_By>;
};

export type Text_Comparison_Exp = {
  _eq?: Maybe<Scalars['String']>;
  _gt?: Maybe<Scalars['String']>;
  _gte?: Maybe<Scalars['String']>;
  _ilike?: Maybe<Scalars['String']>;
  _in?: Maybe<Array<Maybe<Scalars['String']>>>;
  _is_null?: Maybe<Scalars['Boolean']>;
  _like?: Maybe<Scalars['String']>;
  _lt?: Maybe<Scalars['String']>;
  _lte?: Maybe<Scalars['String']>;
  _neq?: Maybe<Scalars['String']>;
  _nilike?: Maybe<Scalars['String']>;
  _nin?: Maybe<Array<Maybe<Scalars['String']>>>;
  _nlike?: Maybe<Scalars['String']>;
  _nsimilar?: Maybe<Scalars['String']>;
  _similar?: Maybe<Scalars['String']>;
};


export type Token = {
  __typename?: 'Token';
  asset: Asset;
  quantity: Scalars['String'];
  transactionOutput: TransactionOutput;
};

export type Token_Aggregate = {
  __typename?: 'Token_aggregate';
  aggregate?: Maybe<Token_Aggregate_Fields>;
  nodes: Array<Token>;
};

export type Token_Aggregate_Fields = {
  __typename?: 'Token_aggregate_fields';
  count: Scalars['String'];
  max: Token_Max_Fields;
  min: Token_Min_Fields;
  sum: Token_Sum_Fields;
};

export type Token_Bool_Exp = {
  _and?: Maybe<Array<Maybe<Token_Bool_Exp>>>;
  _not?: Maybe<Token_Bool_Exp>;
  _or?: Maybe<Array<Maybe<Token_Bool_Exp>>>;
  asset?: Maybe<Asset_Bool_Exp>;
  quantity?: Maybe<Text_Comparison_Exp>;
  transactionOutput?: Maybe<TransactionOutput_Bool_Exp>;
};

export type Token_Max_Fields = {
  __typename?: 'Token_max_fields';
  quantity?: Maybe<Scalars['String']>;
};

export type Token_Min_Fields = {
  __typename?: 'Token_min_fields';
  quantity?: Maybe<Scalars['String']>;
};

export type Token_Order_By = {
  asset?: Maybe<Asset_Order_By>;
  quantity?: Maybe<Order_By>;
};

export type Token_Sum_Fields = {
  __typename?: 'Token_sum_fields';
  quantity?: Maybe<Scalars['String']>;
};

export type TokenMint = {
  __typename?: 'TokenMint';
  asset: Asset;
  quantity: Scalars['String'];
  transaction: Transaction;
};

export type TokenMint_Aggregate = {
  __typename?: 'TokenMint_aggregate';
  aggregate?: Maybe<TokenMint_Aggregate_Fields>;
  nodes: Array<TokenMint>;
};

export enum TokenMint_Aggregate_Distinct_On {
  AssetId = 'assetId',
  PolicyId = 'policyId'
}

export type TokenMint_Aggregate_Fields = {
  __typename?: 'TokenMint_aggregate_fields';
  count: Scalars['String'];
  max: TokenMint_Max_Fields;
  min: TokenMint_Min_Fields;
  sum: TokenMint_Sum_Fields;
};

export type TokenMint_Bool_Exp = {
  _and?: Maybe<Array<Maybe<TokenMint_Bool_Exp>>>;
  _not?: Maybe<TokenMint_Bool_Exp>;
  _or?: Maybe<Array<Maybe<TokenMint_Bool_Exp>>>;
  asset?: Maybe<Asset_Bool_Exp>;
  quantity?: Maybe<Text_Comparison_Exp>;
  transaction?: Maybe<Transaction_Bool_Exp>;
};

export type TokenMint_Max_Fields = {
  __typename?: 'TokenMint_max_fields';
  quantity?: Maybe<Scalars['String']>;
};

export type TokenMint_Min_Fields = {
  __typename?: 'TokenMint_min_fields';
  quantity?: Maybe<Scalars['String']>;
};

export type TokenMint_Order_By = {
  asset?: Maybe<Asset_Order_By>;
  quantity?: Maybe<Order_By>;
  transaction?: Maybe<Transaction_Order_By>;
};

export type TokenMint_Sum_Fields = {
  __typename?: 'TokenMint_sum_fields';
  quantity?: Maybe<Scalars['String']>;
};

export type Transaction = {
  __typename?: 'Transaction';
  block?: Maybe<Block>;
  blockIndex: Scalars['Int'];
  collateralInputs?: Maybe<Array<Maybe<CollateralInput>>>;
  collateralInputs_aggregate: CollateralInput_Aggregate;
  collateralOutputs?: Maybe<Array<Maybe<CollateralOutput>>>;
  collateralOutputs_aggregate: CollateralOutput_Aggregate;
  deposit: Scalars['Lovelace'];
  fee: Scalars['Lovelace'];
  hash: Scalars['Hash32Hex'];
  inputs: Array<TransactionInput>;
  inputs_aggregate: TransactionInput_Aggregate;
  invalidBefore?: Maybe<Scalars['String']>;
  invalidHereafter?: Maybe<Scalars['String']>;
  metadata?: Maybe<Array<Maybe<TransactionMetadata>>>;
  mint: Array<Token>;
  mint_aggregate: Token_Aggregate;
  outputs: Array<Maybe<TransactionOutput>>;
  outputs_aggregate: TransactionOutput_Aggregate;
  redeemers?: Maybe<Array<Maybe<Redeemer>>>;
  referenceInputs: Array<TransactionInput>;
  referenceInputs_aggregate: TransactionInput_Aggregate;
  scripts?: Maybe<Array<Maybe<Script>>>;
  scriptSize: Scalars['Int'];
  size: Scalars['Int'];
  totalOutput: Scalars['Lovelace'];
  includedAt: Scalars['DateTime'];
  validContract: Scalars['Boolean'];
  withdrawals: Array<Maybe<Withdrawal>>;
  withdrawals_aggregate: Withdrawal_Aggregate;
};


export type TransactionCollateralInputsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Maybe<CollateralInput_Order_By>>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<CollateralInput_Bool_Exp>;
};


export type TransactionCollateralInputs_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Maybe<CollateralInput_Order_By>>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<CollateralInput_Bool_Exp>;
};


export type TransactionCollateralOutputsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Maybe<CollateralOutput_Order_By>>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<CollateralOutput_Bool_Exp>;
};


export type TransactionCollateralOutputs_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Maybe<CollateralOutput_Order_By>>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<CollateralOutput_Bool_Exp>;
};


export type TransactionInputsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Maybe<TransactionInput_Order_By>>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<TransactionInput_Bool_Exp>;
};


export type TransactionInputs_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Maybe<TransactionInput_Order_By>>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<TransactionInput_Bool_Exp>;
};


export type TransactionMintArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Maybe<Token_Order_By>>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Token_Bool_Exp>;
};


export type TransactionMint_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Maybe<Token_Order_By>>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Token_Bool_Exp>;
};


export type TransactionOutputsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Maybe<TransactionOutput_Order_By>>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<TransactionOutput_Bool_Exp>;
};


export type TransactionOutputs_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Maybe<TransactionOutput_Order_By>>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<TransactionOutput_Bool_Exp>;
};


export type TransactionReferenceInputsArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Maybe<TransactionInput_Order_By>>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<TransactionInput_Bool_Exp>;
};


export type TransactionReferenceInputs_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Maybe<TransactionInput_Order_By>>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<TransactionInput_Bool_Exp>;
};


export type TransactionWithdrawals_AggregateArgs = {
  limit?: Maybe<Scalars['Int']>;
  order_by?: Maybe<Array<Maybe<Withdrawal_Order_By>>>;
  offset?: Maybe<Scalars['Int']>;
  where?: Maybe<Withdrawal_Bool_Exp>;
};

export type Transaction_Aggregate = {
  __typename?: 'Transaction_aggregate';
  aggregate?: Maybe<Transaction_Aggregate_Fields>;
};

export type Transaction_Aggregate_Fields = {
  __typename?: 'Transaction_aggregate_fields';
  count: Scalars['String'];
  max: Transaction_Max_Fields;
  min: Transaction_Min_Fields;
  sum: Transaction_Sum_Fields;
};

export type Transaction_Bool_Exp = {
  _and?: Maybe<Array<Maybe<Transaction_Bool_Exp>>>;
  _not?: Maybe<Transaction_Bool_Exp>;
  _or?: Maybe<Array<Maybe<Transaction_Bool_Exp>>>;
  block?: Maybe<Block_Bool_Exp>;
  blockIndex?: Maybe<Int_Comparison_Exp>;
  collateral?: Maybe<TransactionInput_Bool_Exp>;
  deposit?: Maybe<Text_Comparison_Exp>;
  fee?: Maybe<Text_Comparison_Exp>;
  hash?: Maybe<Hash32Hex_Comparison_Exp>;
  includedAt?: Maybe<Date_Comparison_Exp>;
  inputs?: Maybe<TransactionInput_Bool_Exp>;
  invalidBefore?: Maybe<Text_Comparison_Exp>;
  invalidHereafter?: Maybe<Text_Comparison_Exp>;
  metadata?: Maybe<TransactionMetadata_Bool_Exp>;
  mint?: Maybe<Token_Bool_Exp>;
  outputs?: Maybe<TransactionOutput_Bool_Exp>;
  scriptSize?: Maybe<Int_Comparison_Exp>;
  size?: Maybe<Int_Comparison_Exp>;
  totalOutput?: Maybe<Text_Comparison_Exp>;
  validContract?: Maybe<Boolean_Comparison_Exp>;
  withdrawals?: Maybe<Withdrawal_Bool_Exp>;
};

export type Transaction_Max_Fields = {
  __typename?: 'Transaction_max_fields';
  deposit?: Maybe<Scalars['Lovelace']>;
  fee?: Maybe<Scalars['Lovelace']>;
  invalidBefore?: Maybe<Scalars['String']>;
  invalidHereafter?: Maybe<Scalars['String']>;
  mint?: Maybe<Token_Max_Fields>;
  scriptSize?: Maybe<Scalars['Int']>;
  size?: Maybe<Scalars['Int']>;
  totalOutput?: Maybe<Scalars['Lovelace']>;
  withdrawals?: Maybe<Withdrawal_Max_Fields>;
};

export type Transaction_Min_Fields = {
  __typename?: 'Transaction_min_fields';
  deposit?: Maybe<Scalars['Lovelace']>;
  fee?: Maybe<Scalars['Lovelace']>;
  invalidBefore?: Maybe<Scalars['String']>;
  invalidHereafter?: Maybe<Scalars['String']>;
  mint?: Maybe<Token_Min_Fields>;
  scriptSize?: Maybe<Scalars['Int']>;
  size?: Maybe<Scalars['Int']>;
  totalOutput?: Maybe<Scalars['Lovelace']>;
  withdrawals?: Maybe<Withdrawal_Min_Fields>;
};

export type Transaction_Order_By = {
  block?: Maybe<Block_Order_By>;
  blockIndex?: Maybe<Order_By>;
  deposit?: Maybe<Order_By>;
  fee?: Maybe<Order_By>;
  hash?: Maybe<Order_By>;
  includedAt?: Maybe<Order_By>;
  invalidBefore?: Maybe<Order_By_With_Nulls>;
  invalidHereafter?: Maybe<Order_By_With_Nulls>;
  scriptSize?: Maybe<Order_By_With_Nulls>;
  size?: Maybe<Order_By>;
  totalOutput?: Maybe<Order_By>;
  validContract?: Maybe<Order_By>;
  withdrawals?: Maybe<Order_By>;
};

export type Transaction_Sum_Fields = {
  __typename?: 'Transaction_sum_fields';
  deposit?: Maybe<Scalars['Lovelace']>;
  fee?: Maybe<Scalars['Lovelace']>;
  mint?: Maybe<Token_Sum_Fields>;
  scriptSize?: Maybe<Scalars['BigInt']>;
  size?: Maybe<Scalars['BigInt']>;
  totalOutput?: Maybe<Scalars['Lovelace']>;
  withdrawals?: Maybe<Withdrawal_Sum_Fields>;
};

export type TransactionInput = {
  __typename?: 'TransactionInput';
  address: Scalars['String'];
  redeemer?: Maybe<Redeemer>;
  sourceTransaction: Transaction;
  sourceTxHash: Scalars['Hash32Hex'];
  sourceTxIndex: Scalars['Int'];
  tokens: Array<Maybe<Token>>;
  tokens_aggregate: Token_Aggregate;
  transaction: Transaction;
  txHash: Scalars['Hash32Hex'];
  value: Scalars['Lovelace'];
};

export type TransactionInput_Aggregate = {
  __typename?: 'TransactionInput_aggregate';
  aggregate?: Maybe<TransactionInput_Aggregate_Fields>;
};

export type TransactionInput_Aggregate_Fields = {
  __typename?: 'TransactionInput_aggregate_fields';
  count: Scalars['String'];
  max: TransactionInput_Max_Fields;
  min: TransactionInput_Min_Fields;
  sum: TransactionInput_Sum_Fields;
};

export type TransactionInput_Bool_Exp = {
  _and?: Maybe<Array<Maybe<TransactionInput_Bool_Exp>>>;
  _not?: Maybe<TransactionInput_Bool_Exp>;
  _or?: Maybe<Array<Maybe<TransactionInput_Bool_Exp>>>;
  address?: Maybe<Text_Comparison_Exp>;
  sourceTransaction?: Maybe<Transaction_Bool_Exp>;
  tokens?: Maybe<Token_Bool_Exp>;
  transaction?: Maybe<Transaction_Bool_Exp>;
  value?: Maybe<Text_Comparison_Exp>;
};

export type TransactionInput_Max_Fields = {
  __typename?: 'TransactionInput_max_fields';
  tokens?: Maybe<Token_Max_Fields>;
  value?: Maybe<Scalars['Lovelace']>;
};

export type TransactionInput_Min_Fields = {
  __typename?: 'TransactionInput_min_fields';
  tokens?: Maybe<Token_Min_Fields>;
  value?: Maybe<Scalars['Lovelace']>;
};

export type TransactionInput_Order_By = {
  address?: Maybe<Order_By>;
  sourceTxHash?: Maybe<Order_By>;
  transaction?: Maybe<Transaction_Order_By>;
  txHash?: Maybe<Order_By>;
  value?: Maybe<Order_By>;
};

export type TransactionInput_Sum_Fields = {
  __typename?: 'TransactionInput_sum_fields';
  tokens?: Maybe<Token_Sum_Fields>;
  value?: Maybe<Scalars['Lovelace']>;
};

export type TransactionMetadata = {
  __typename?: 'TransactionMetadata';
  key: Scalars['String'];
  value: Scalars['JSON'];
};

export type TransactionMetadata_Bool_Exp = {
  key?: Maybe<Text_Comparison_Exp>;
};

export type TransactionOutput = {
  __typename?: 'TransactionOutput';
  address: Scalars['String'];
  addressHasScript: Scalars['Boolean'];
  datum?: Maybe<Datum>;
  index: Scalars['Int'];
  paymentCredential?: Maybe<Scalars['Hash28Hex']>;
  script?: Maybe<Script>;
  transaction: Transaction;
  txHash: Scalars['Hash32Hex'];
  tokens: Array<Token>;
  tokens_aggregate: Token_Aggregate;
  value: Scalars['Lovelace'];
};

export type TransactionOutput_Aggregate = {
  __typename?: 'TransactionOutput_aggregate';
  aggregate?: Maybe<TransactionOutput_Aggregate_Fields>;
};

export type TransactionOutput_Aggregate_Fields = {
  __typename?: 'TransactionOutput_aggregate_fields';
  count: Scalars['String'];
  max: TransactionOutput_Max_Fields;
  min: TransactionOutput_Min_Fields;
  sum: TransactionOutput_Sum_Fields;
};

export type TransactionOutput_Bool_Exp = {
  _and?: Maybe<Array<Maybe<TransactionOutput_Bool_Exp>>>;
  _not?: Maybe<TransactionOutput_Bool_Exp>;
  _or?: Maybe<Array<Maybe<TransactionOutput_Bool_Exp>>>;
  address?: Maybe<Text_Comparison_Exp>;
  addressHasScript?: Maybe<Boolean_Comparison_Exp>;
  datum?: Maybe<Datum_Bool_Exp>;
  index?: Maybe<Int_Comparison_Exp>;
  script?: Maybe<Script_Bool_Exp>;
  tokens?: Maybe<Token_Bool_Exp>;
  transaction?: Maybe<Transaction_Bool_Exp>;
  value?: Maybe<Text_Comparison_Exp>;
};

export enum TransactionOutput_Distinct_On {
  Address = 'address'
}

export type TransactionOutput_Max_Fields = {
  __typename?: 'TransactionOutput_max_fields';
  tokens?: Maybe<Token_Max_Fields>;
  value?: Maybe<Scalars['Lovelace']>;
};

export type TransactionOutput_Min_Fields = {
  __typename?: 'TransactionOutput_min_fields';
  tokens?: Maybe<Token_Min_Fields>;
  value?: Maybe<Scalars['Lovelace']>;
};

export type TransactionOutput_Order_By = {
  address?: Maybe<Order_By>;
  addressHasScript?: Maybe<Order_By>;
  datum?: Maybe<Transaction_Order_By>;
  index?: Maybe<Order_By>;
  txHash?: Maybe<Order_By>;
  value?: Maybe<Order_By>;
};

export type TransactionOutput_Sum_Fields = {
  __typename?: 'TransactionOutput_sum_fields';
  tokens?: Maybe<Token_Sum_Fields>;
  value?: Maybe<Scalars['Lovelace']>;
};

export type TransactionSubmitResponse = {
  __typename?: 'TransactionSubmitResponse';
  hash: Scalars['String'];
};


export type VrfVerificationKey_Comparison_Exp = {
  _eq?: Maybe<Scalars['VRFVerificationKey']>;
  _in?: Maybe<Array<Maybe<Scalars['VRFVerificationKey']>>>;
  _is_null?: Maybe<Scalars['Boolean']>;
  _neq?: Maybe<Scalars['VRFVerificationKey']>;
  _nin?: Maybe<Array<Maybe<Scalars['VRFVerificationKey']>>>;
};

export type Withdrawal = {
  __typename?: 'Withdrawal';
  address: Scalars['StakeAddress'];
  amount: Scalars['Lovelace'];
  redeemer?: Maybe<Redeemer>;
  transaction: Transaction;
};

export type Withdrawal_Aggregate = {
  __typename?: 'Withdrawal_aggregate';
  aggregate: Withdrawal_Aggregate_Fields;
};

export type Withdrawal_Aggregate_Fields = {
  __typename?: 'Withdrawal_aggregate_fields';
  count: Scalars['String'];
  max: Withdrawal_Max_Fields;
  min: Withdrawal_Min_Fields;
  sum: Withdrawal_Sum_Fields;
};

export type Withdrawal_Bool_Exp = {
  _and?: Maybe<Array<Maybe<Withdrawal_Bool_Exp>>>;
  _not?: Maybe<Withdrawal_Bool_Exp>;
  _or?: Maybe<Array<Maybe<Withdrawal_Bool_Exp>>>;
  address?: Maybe<StakeAddress_Comparison_Exp>;
  amount?: Maybe<Text_Comparison_Exp>;
  transaction?: Maybe<Transaction_Bool_Exp>;
};

export type Withdrawal_Max_Fields = {
  __typename?: 'Withdrawal_max_fields';
  amount?: Maybe<Scalars['Lovelace']>;
};

export type Withdrawal_Min_Fields = {
  __typename?: 'Withdrawal_min_fields';
  amount?: Maybe<Scalars['Lovelace']>;
};

export type Withdrawal_Order_By = {
  address?: Maybe<Order_By>;
  amount?: Maybe<Order_By>;
  transaction?: Maybe<Transaction_Order_By>;
};

export type Withdrawal_Sum_Fields = {
  __typename?: 'Withdrawal_sum_fields';
  amount?: Maybe<Scalars['Lovelace']>;
};
